﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
'Note: My project will not use Reinitialize method. It uses Reinitialize2 because its written differently.  I need to convert to this Reinialize method.
'Setting Borders to White color will be originally the way it was designed by klaus but slightly smaller scale with needles and ticks

'For Others Do these step 
' Step 1: Enable the Reinitialize Event 
' Step 2: Enable InitGauge in AddToParent
' Step 3: Disable in Main Reinitialize2 Method (in InitGauge Event)

'xGauge Custom View class
'Version 2.1 2019.03.30
'Added 320, 90 Right, Digital Circle, Digital Square Degree Gauges
'Added Bevel, Thickborder(Digital Only), Rounded Corners, Gradient Background for Digital Only
'Added Digital Value in Analog Gauges
'Adjustment with Scale(Decreased) to allow borders

'Version 1.5 2019.03.07
'Amended cScaleMidLimitColor initialize value from 526 to 255
'Amended setScaleColor missing reinitialize call routine
'Amended Rotate Needle equation correction
'Improved scale custom angles management
'Added cCustomScaleMinAngle and cCustomScaleMaxAngle variables
'Added NeedleON property shows or hides the needle
'
'Version 1.4 2019.03.06
'Amended NeedleBitmapFileName designation in custom properties
'Amended NeedleBitmapFileName set in the code for a Gaige added in the Designer
'Amended custom angles problems.
'Added RemoveView and ReInitialize methods
'
'Version 1.3 2018.12.20
'improved CustumScaleAngle management
'
'Version 1.2 2018.12.13
'amended display of GaugeTitle and GaugeUnit
'
'Version 1.1 2018.11.04
'improved Custom scale angles gauges
'changed custom scale angle definition positive angles become negative angles
'
'Version 1.0 2018.10.28
'
'Written by Klaus CHRISTL (klaus)
'
#DesignerProperty: Key: GaugeType, DisplayName: GaugeType, FieldType: String, DefaultValue: 90° Top, List: 90° Top|180°|270°|90° Left|Custom scale angles, Description: Gauge type.
#DesignerProperty: Key: ValueMax, DisplayName: ValueMax, FieldType: Int, DefaultValue: 100, Description: max value of the scale.
#DesignerProperty: Key: ValueMin, DisplayName: ValueMin, FieldType: Int, DefaultValue: 0, Description: min value of the scale.
#DesignerProperty: Key: GaugeTitle, DisplayName: GaugeTitle, FieldType: String, DefaultValue: Fuel, Description: Title text of the gauge type.
#DesignerProperty: Key: GaugeUnit, DisplayName: GaugeUnit, FieldType: String, DefaultValue: , Description: Gauge unit.
#DesignerProperty: Key: CustomScaleStartAngle, DisplayName: CustomScaleStartAngle, FieldType: Int, DefaultValue: 225, Description: Start angle of custom scale. Trigonometric angles 0 at 3 o'clock. Positive clockwise.
#DesignerProperty: Key: CustomScaleEndAngle, DisplayName: CustomScaleEndAngle, FieldType: Int, DefaultValue: 0, Description: End angle of custom scale. Trigonometric angles 0 at 3 o'clock. Positive clockwise.
#DesignerProperty: Key: NeedleBitmapFileName, DisplayName: NeedleBitmapFileName, FieldType: String, DefaultValue: no file, Description: File name of the needle bitmap the file must be in Files.DirAssets enter 'no file' without the quotes to use the default needle.
#DesignerProperty: Key: BackgroundColor, DisplayName: BackgroundColor, FieldType: Color, DefaultValue: 0xFF000000, Description: color of the background.
#DesignerProperty: Key: ScaleColor, DisplayName: ScaleColor, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: color of the scale.
#DesignerProperty: Key: NeedleColor, DisplayName: NeedleColor, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: color of the needle.
#DesignerProperty: Key: NeedleON, DisplayName: NeedleON, FieldType: Boolean, DefaultValue: True, Description: displays the neddle or not.
#DesignerProperty: Key: MainTickNumber, DisplayName: MainTickNumber, FieldType: Int, DefaultValue: 5, Description: number of main ticks.
#DesignerProperty: Key: HalfTicks, DisplayName: HalfTicks, FieldType: Boolean, DefaultValue: True, Description: set also half ticks.
#DesignerProperty: Key: SmallTicksNumber, DisplayName: SmallTicksNumber, FieldType: Int, DefaultValue: 0, Description: set also x small ticks between two main ticks.
#DesignerProperty: Key: TickText, DisplayName: TickText, FieldType: String, DefaultValue: E|1/2|F, Description: Text of the gauge type.
#DesignerProperty: Key: ScaleLowLimitPerCent, DisplayName: ScaleLowLimitPerCent, FieldType: Int, DefaultValue: 0, Description: per cent of the scale low limit.
#DesignerProperty: Key: ScaleLowLimitColor, DisplayName: ScaleLowLimitColor, FieldType: Color, DefaultValue: 0xFF32CD32, Description: color of the scale low limit.
#DesignerProperty: Key: ScaleHighLimitPerCent, DisplayName: ScaleHighLimitPerCent, FieldType: Int, DefaultValue: 0, Description: per cent of the scale high limit.
#DesignerProperty: Key: ScaleHighLimitColor, DisplayName: ScaleHighLimitColor, FieldType: Color, DefaultValue: 0xFFFF0000, Description: color of the scale high limit.
#DesignerProperty: Key: ScaleMidLimitStartPerCent, DisplayName: ScaleMidLimitStartPerCent, FieldType: Int, DefaultValue: 0, Description: start per cent of the scale mid limit.
#DesignerProperty: Key: ScaleMidLimitSweepPerCent, DisplayName: ScaleMidLimitSweepPerCent, FieldType: Int, DefaultValue: 0, Description: sweep per cent of the scale mid limit.
#DesignerProperty: Key: ScaleMidLimitColor, DisplayName: ScaleMidLimitColor, FieldType: Color, DefaultValue: 0xFFFFA500, Description: color of the scale mid limit.

Sub Class_Globals
	
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private xui As XUI

	Private pnlGauge As B4XView
	Private pnlNeedle As B4XView
	Private cvsGauge, cvsNeedle As B4XCanvas
	Private rectGauge, rectNeedle As B4XRect
	Private cParent As B4XView
	
	Private cLeft, cTop, cWidth, cHeight As Int
	Private cMainTickNumber As Int
	Private cHalfTicks As Boolean
	Private cValue, cValueMin, cValueMax, cStartAngle, cEndAngle, cFullScaleAngle, cCustomScaleStartAngle, cCustomScaleEndAngle, cCustomScaleMinAngle, cCustomScaleMaxAngle  As Double
	Private cScaleLowLimitPerCent, cScaleHighLimitPerCent, cScaleMidLimitStartPerCent, cScaleMidLimitSweepPerCent As Double
	Private cBackgroundColor, cScaleColor, cNeedleColor, cScaleLowLimitColor, cScaleHighLimitColor, cScaleMidLimitColor As Int
	Private cGaugeTitleTextSize, cGaugeUnitTextSize, cScaleTextSize As Float
	Private cGaugeType, cGaugeTitle, cGaugeUnit As String
	Private cTickText As String
	Private NeedleWidth, NeedleHeight, NeedleCenterX, NeedleCenterY, ScaleStroke, ScaleHalfStroke, ScaleSmallStroke, ScaleTextHeight, DeltaTextBottom As Int
	Private RadiusInner, RadiusHalfTick, RadiusSmallTick, RadiusTick, RadiusScale As Int
	Private GaugeTextX, GaugeTextY, GaugeUnitX, GaugeUnitY As Int
	Private cSmallTicksNumber As Int
	Private cNeedleBitmapFileName As String
	Private cNeedleIndex As Int
	Private cNeedleON As Boolean
	
	
	'These are new. For Digital Gauges and Colors
	Private cTag As String
	Private cDigitalValueTextSize, cAnalogValueTextSize As Float
	
	Private GaugeDigitalValueX, GaugeDigitalValueY, GaugeDigitalMinX, GaugeDigitalMinY, GaugeDigitalMaxX, GaugeDigitalMaxY As Int
	Private GaugeAnalogValueX, GaugeAnalogValueY As Int
	
	Private cvsDigital, cvsDigital2 As B4XCanvas
	Private pnlDigital, pnlDigital2 As B4XView
	Private rectDigital, rectDigital2, rectGauge2 As B4XRect
	Private cDigitalValueColor As Int
	Private cDigitalBackgroundColor As Int
	Private cDigitalBackgroundColor2 As Int
	Private cDigitalBorderColor As Int
	Private cDigitalBorderColor2 As Int
	Private cDigitalBorderColor2 As Int
	Private CDigitalTitleColor As Int
	Private CDigitalUnitColor As Int
	Private cDigitalRoundedCorner As Boolean
	Private cDigitalThickBorder As Boolean
	
	Private cAnalogBorderColor As Int		
	Private cAnalogBorderColor2 As Int			
	Private cAnalogTitleColor As Int
	Private cAnalogUnitColor As Int
	Private cAnalogValueColor As Int
	Private cAnalogValueON As Boolean
	Private cAnalogRoundedCorner As Boolean
	
	Private cAnalogInnerBevel As Boolean
	Private cDigitalInnerBevel As Boolean
	
	Private cBasicDrawing As Boolean
	
	Private cDigitalMinMaxON As Boolean
	
	
End Sub

'Initializes a xGauge
'Callback is the calling module
'EventName is the generic event name, not used
Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	'define default values
	cValueMin = 0
	cValueMax = 100
	cGaugeType = "270°"
	cGaugeTitle = "Speed"
	cGaugeUnit = ""
	cTickText = "0|2|4|6|8|10"
	cMainTickNumber = 11
	cHalfTicks = True
	cSmallTicksNumber = 0
	cCustomScaleStartAngle = -225
	cCustomScaleEndAngle = 0
	cCustomScaleMinAngle = 45
	cCustomScaleMaxAngle = 330
	cBackgroundColor = xui.Color_White
	cScaleColor = xui.Color_Black
	cNeedleColor  = xui.Color_Gray
	cNeedleBitmapFileName = "no file"
	cNeedleON = True
	cScaleLowLimitPerCent = 0
	cScaleLowLimitColor = xui.Color_RGB(50, 205, 50)
	cScaleHighLimitPerCent = 0
	cScaleHighLimitColor = xui.Color_Red
	cScaleMidLimitStartPerCent = 0
	cScaleMidLimitSweepPerCent = 0
	cScaleMidLimitColor = xui.Color_RGB(255, 165, 0)
	
	'New here and below
	cDigitalValueColor = xui.Color_DarkGray
	cDigitalBackgroundColor = xui.Color_White
	cDigitalBackgroundColor2 = xui.Color_White
	cDigitalBorderColor = xui.Color_Gray
	cDigitalBorderColor2 = xui.Color_DarkGray
	CDigitalTitleColor = xui.Color_Black
	CDigitalUnitColor = xui.Color_Black
	cDigitalRoundedCorner = True
	cDigitalThickBorder = False
	
	cAnalogBorderColor = xui.Color_Gray
	cAnalogBorderColor2 = xui.Color_DarkGray
	cAnalogTitleColor = xui.Color_Black
	cAnalogUnitColor = xui.Color_Black
	cAnalogValueColor = xui.Color_DarkGray
	cAnalogValueON = True
	cAnalogRoundedCorner = False
	
	cAnalogInnerBevel = False
	cDigitalInnerBevel = False
	
	cBasicDrawing = False	
	cDigitalMinMaxON = True
End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	pnlGauge = Base
	cLeft = pnlGauge.Left
	cTop = pnlGauge.Top
	cWidth = pnlGauge.Width
	cParent = pnlGauge.Parent
	
	cGaugeType = Props.Get("GaugeType")
	cNeedleBitmapFileName = Props.Get("NeedleBitmapFileName")
	cValueMin = Props.Get("ValueMin")
	cValueMax = Props.Get("ValueMax")
	cGaugeTitle = Props.Get("GaugeTitle")
	cGaugeUnit = Props.Get("GaugeUnit")
	cCustomScaleStartAngle = Props.Get("CustomScaleStartAngle")
	cCustomScaleEndAngle = Props.Get("CustomScaleEndAngle")
	cTickText = Props.Get("TickText")
	cMainTickNumber = Props.Get("MainTickNumber")
	cHalfTicks = Props.Get("HalfTicks")
	cSmallTicksNumber = Props.Get("SmallTicksNumber")
	cBackgroundColor = xui.PaintOrColorToColor(Props.Get("BackgroundColor"))
	cScaleColor = xui.PaintOrColorToColor(Props.Get("ScaleColor"))
	cNeedleColor = xui.PaintOrColorToColor(Props.Get("NeedleColor"))
	cNeedleON = Props.Get("NeedleON")
	cScaleLowLimitPerCent = Props.Get("ScaleLowLimitPerCent")
	cScaleLowLimitColor =  xui.PaintOrColorToColor(Props.Get("ScaleLowLimitColor"))
	cScaleHighLimitPerCent = Props.Get("ScaleHighLimitPerCent")
	cScaleHighLimitColor =  xui.PaintOrColorToColor(Props.Get("ScaleHighLimitColor"))
	cScaleMidLimitStartPerCent = Props.Get("ScaleMidLimitStartPerCent")
	cScaleMidLimitSweepPerCent = Props.Get("ScaleMidLimitSweepPerCent")
	cScaleMidLimitColor = xui.PaintOrColorToColor(Props.Get("ScaleMidLimitColor"))
	
	'New here and below
	cDigitalValueColor = xui.Color_DarkGray
	cDigitalBackgroundColor = xui.Color_White
	cDigitalBackgroundColor2 = xui.Color_White
	cDigitalBorderColor = xui.Color_Gray
	cDigitalBorderColor2 = xui.Color_DarkGray
	CDigitalTitleColor = xui.Color_Black
	CDigitalUnitColor = xui.Color_Black
	cDigitalRoundedCorner = True
	cDigitalThickBorder = False
	
	cAnalogBorderColor = xui.Color_Gray
	cAnalogBorderColor2 = xui.Color_DarkGray
	cAnalogTitleColor = xui.Color_Black
	cAnalogUnitColor = xui.Color_Black
	cAnalogValueColor = xui.Color_DarkGray
	cAnalogValueON = True
	cAnalogRoundedCorner = False
	
	cAnalogInnerBevel = False
	cDigitalInnerBevel = False
	
	cBasicDrawing = False
	cDigitalMinMaxON = True
	
	cHeight = cWidth
	Select cGaugeType
		Case "180°"
			cHeight = 0.7 * cWidth
		Case "Custom scale angles"
			cStartAngle = cCustomScaleStartAngle
			cEndAngle = cCustomScaleEndAngle
			If cEndAngle < cStartAngle Then
				#If B4J
				LogError("Error in CustomScaleAngles xChart! End angle " & cEndAngle & " smaller than Start angle " & cStartAngle & " !  Angle zero at 3 o'clock, postive clockwise!")
				#Else
				LogColor("Error in CustomScaleAngles xChart! End angle " & cEndAngle & " smaller than Start angle " & cStartAngle & " !  Angle zero at 3 o'clock, postive clockwise!", Colors.Red)
				#End If
			End If
			If cStartAngle >= -190 And cStartAngle < -90 And cEndAngle > -90 And cEndAngle <= 10 Then
				cHeight = 0.7 * cWidth
			End If
	End Select
	pnlGauge.Height = cHeight
	
	InitGauge
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	setWidth(Width)
End Sub

'adds the xGauge to the Parent view.
'the parent object can be a B4XView or
'an Activity or a Panel in B4A, a Panel in B4i or a Pane in B4J
'there is no Height property, because the Height = Width 
Public Sub AddToParent(Parent As Object, Left As Int, Top As Int, Width As Int)
	cLeft = Left
	cTop = Top
	cWidth = Width
	cParent = Parent
	InitHeight
	
	pnlGauge = xui.CreatePanel("pnlGauge")
	cParent.AddView(pnlGauge, cLeft, cTop, cWidth, cHeight)
	
'	InitGauge	'not using in my project (must be enabled for other to use)
End Sub

Private Sub InitGauge

	Private rectGaugeTitle, rectScaleText As B4XRect

	cvsGauge.Initialize(pnlGauge)	'This panel is for All Gauges Type

	Select cGaugeType
		Case "90° Top","180°", "270°", "90° Left", "Custom scale angles", "320°", "90° Right"
			cGaugeTitleTextSize = 0.07 * cWidth / xui.Scale
			cGaugeUnitTextSize = 0.06 * cWidth / xui.Scale
			cScaleTextSize = 0.06 * cWidth / xui.Scale
			
			cAnalogValueTextSize = 0.07 * cWidth / xui.Scale
						
			rectGaugeTitle = cvsGauge.MeasureText("Ag", xui.CreateDefaultFont(cGaugeTitleTextSize))
			rectScaleText = cvsGauge.MeasureText("Ag", xui.CreateDefaultFont(cScaleTextSize))
			ScaleTextHeight = 0.6 * rectScaleText.Height
			
			rectGauge.Initialize(0, 0, cWidth, cHeight)
			
		Case "Digital Square"
			cGaugeTitleTextSize = 0.09 * cWidth / xui.Scale
			cGaugeUnitTextSize = 0.09 * cWidth / xui.Scale
			
			cDigitalValueTextSize = 0.18 * cWidth / xui.Scale
						
			rectGauge2.Initialize(0, 0, cWidth, cHeight)
		
		Case "Digital Circle"
			cGaugeTitleTextSize = 0.09 * cWidth / xui.Scale
			cGaugeUnitTextSize = 0.09 * cWidth / xui.Scale
			
			cDigitalValueTextSize = 0.18 * cWidth / xui.Scale
						
			rectGauge2.Initialize(0, 0, cWidth, cHeight)
	End Select
		
	Private ScaleStrokeDivider = 70 As Int
	Select cGaugeType
		Case "90° Top"
			cStartAngle = -135
			cEndAngle = -45
	
			ScaleStroke = cWidth / ScaleStrokeDivider
			RadiusInner = 0.46 * cWidth
			RadiusHalfTick = 0.50 * cWidth
			RadiusSmallTick = 0.485 * cWidth
			RadiusTick = 0.53 * cWidth
			RadiusScale = 0.56 * cWidth
			
			NeedleCenterX = cWidth / 2
			NeedleCenterY = 0.75 * cWidth
			NeedleHeight = 2 * RadiusInner
			NeedleWidth = NeedleHeight / 340 * 27
			
			GaugeTextX = cWidth / 2
			GaugeTextY = 0.5 * cWidth		
			If cAnalogValueON = True Then
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + (1.1 * 2) * rectGaugeTitle.Height
			Else
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + 1.1 * rectGaugeTitle.Height
			End If
			GaugeAnalogValueX = GaugeTextX
			GaugeAnalogValueY =  GaugeTextY + 1.1 * rectGaugeTitle.Height
			
			DeltaTextBottom = 0
			cNeedleIndex = 0
			
		Case "180°"
			cStartAngle = -180
			cEndAngle = 0
	
			ScaleStroke = cWidth / ScaleStrokeDivider
			RadiusInner = 0.35 * cWidth
			RadiusHalfTick = 0.39 * cWidth
			RadiusSmallTick = 0.375 * cWidth
			RadiusTick = 0.42 * cWidth
			
			RadiusScale = 0.29 * cWidth
			NeedleCenterX = cWidth / 2
			NeedleCenterY = 0.55 * cWidth
			NeedleHeight = 2 * RadiusInner
			NeedleWidth = NeedleHeight / 340 * 27	
			If cAnalogValueON = True Then
				GaugeTextX = cWidth / 2
				GaugeTextY = 0.37 * cWidth
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + (1.1 * 2) * rectGaugeTitle.Height
			Else
				GaugeTextX = cWidth / 2
				GaugeTextY = 0.40 * cWidth
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + 1.1 * rectGaugeTitle.Height
			End If
			GaugeAnalogValueX = GaugeTextX
			GaugeAnalogValueY =  GaugeTextY + 1.1 * rectGaugeTitle.Height
			
			DeltaTextBottom = 0.6 * ScaleTextHeight
			cNeedleIndex = 0
			
		Case "270°"
			cStartAngle = -225
			cEndAngle = 45
	
			ScaleStroke = cWidth / ScaleStrokeDivider
			RadiusInner = 0.35 * cWidth
			RadiusHalfTick = 0.39 * cWidth
			RadiusSmallTick = 0.375 * cWidth
			RadiusTick = 0.42 * cWidth
			RadiusScale = 0.29 * cWidth
			
			NeedleCenterX = cWidth / 2
			NeedleCenterY = 0.55 * cWidth
			NeedleHeight = 2 * RadiusInner
			NeedleWidth = NeedleHeight / 340 * 27
			
			GaugeTextX = cWidth / 2
			GaugeTextY = 0.7 * cWidth
			If cAnalogValueON = True Then
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + (1.1 * 2) * rectGaugeTitle.Height
			Else
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + 1.1 * rectGaugeTitle.Height
			End If
			GaugeAnalogValueX = GaugeTextX
			GaugeAnalogValueY =  GaugeTextY + 1.1 * rectGaugeTitle.Height
			
			DeltaTextBottom = 0.6 * ScaleTextHeight
			cNeedleIndex = 0
			
		Case "90° Left"
			cStartAngle = -180
			cEndAngle = -90
	
			ScaleStroke = cWidth / ScaleStrokeDivider
			RadiusInner = 0.74 * cWidth
			RadiusHalfTick = 0.78 * cWidth
			RadiusSmallTick = 0.765 * cWidth
			RadiusTick = 0.81 * cWidth
			RadiusScale = 0.67 * cWidth
			
			NeedleCenterX = 0.88 * cWidth
			NeedleCenterY = 0.88 * cWidth
			NeedleHeight = 2 * RadiusInner
			NeedleWidth = NeedleHeight / 340 * 20
			
			GaugeTextX = 0.7 * cWidth
			GaugeTextY = 0.65 * cWidth
			If cAnalogValueON = True Then
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + (1.1 * 2) * rectGaugeTitle.Height
			Else
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + 1.1 * rectGaugeTitle.Height
			End If
			GaugeAnalogValueX = GaugeTextX
			GaugeAnalogValueY =  GaugeTextY + 1.1 * rectGaugeTitle.Height
			
			DeltaTextBottom = 0.6 * ScaleTextHeight
			
			cScaleTextSize = 0.06 * cWidth / xui.Scale	'remove this?  Adjustment is good for all
			cNeedleIndex = 1
			
		Case "320°"
			cStartAngle = -250
			cEndAngle = 70
	
			ScaleStroke = cWidth / ScaleStrokeDivider
			RadiusInner = 0.35 * cWidth
			RadiusHalfTick = 0.39 * cWidth
			RadiusSmallTick = 0.375 * cWidth
			RadiusTick = 0.42 * cWidth
			RadiusScale = 0.29 * cWidth
			
			NeedleCenterX = cWidth / 2
			NeedleCenterY = cWidth / 2
			NeedleHeight = 2 * RadiusInner
			NeedleWidth = NeedleHeight / 340 * 27
			
			GaugeTextX = cWidth / 2
			GaugeTextY = 0.40 * cWidth
			If cAnalogValueON = True Then
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + (1.1 * 4) * rectGaugeTitle.Height
			Else
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + (1.1 * 3) * rectGaugeTitle.Height
			End If
			GaugeAnalogValueX = GaugeTextX
			GaugeAnalogValueY =  GaugeTextY + (1.1 * 3) * rectGaugeTitle.Height
			
			DeltaTextBottom = 0.6 * ScaleTextHeight
			cNeedleIndex = 0
				
		Case "90° Right"
			cStartAngle = -90
			cEndAngle = 0
			
			ScaleStroke = cWidth / ScaleStrokeDivider
			RadiusInner = 0.74 * cWidth
			RadiusHalfTick = 0.78 * cWidth
			RadiusSmallTick = 0.765 * cWidth
			RadiusTick = 0.81 * cWidth
			RadiusScale = 0.67 * cWidth
			
			NeedleCenterX = 0.12 * cWidth
			NeedleCenterY = 0.88 * cWidth
			NeedleHeight = 2 * RadiusInner
			NeedleWidth = NeedleHeight / 340 * 20
			
			GaugeTextX = 0.3 * cWidth
			GaugeTextY = 0.65 * cWidth
			If cAnalogValueON = True Then
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + (1.1 * 2) * rectGaugeTitle.Height
			Else
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + 1.1 * rectGaugeTitle.Height
			End If
			GaugeAnalogValueX = GaugeTextX
			GaugeAnalogValueY =  GaugeTextY + 1.1 * rectGaugeTitle.Height
			
			DeltaTextBottom = 0.6 * ScaleTextHeight
			cNeedleIndex = 1
			
			cScaleTextSize = 0.06 * cWidth / xui.Scale 'remove this?  Adjustment is good for all
							
		Case "Digital Square"
			GaugeTextX = cWidth / 2
			GaugeTextY = 0.28 * cWidth
			GaugeUnitX = GaugeTextX
			GaugeUnitY = 0.75 * cWidth

			GaugeDigitalValueX = GaugeTextX
			GaugeDigitalValueY = 0.55 * cHeight
			
			GaugeDigitalMinX = 0.26 * cWidth
			GaugeDigitalMinY = 0.87 * cHeight
			
			GaugeDigitalMaxX = 0.74 * cWidth
			GaugeDigitalMaxY = 0.87 * cHeight
			
		Case "Digital Circle"
			GaugeTextX = cWidth / 2
			GaugeTextY = 0.28 * cWidth
			GaugeUnitX = GaugeTextX
			GaugeUnitY = 0.75 * cWidth

			GaugeDigitalValueX = GaugeTextX
			GaugeDigitalValueY = 0.55 * cHeight
			
			GaugeDigitalMinX = 0.26 * cWidth
			GaugeDigitalMinY = 0.87 * cHeight
			
			GaugeDigitalMaxX = 0.74 * cWidth
			GaugeDigitalMaxY = 0.87 * cHeight
			
		Case "Custom scale angles"
			cStartAngle = cCustomScaleStartAngle
			cEndAngle = cCustomScaleEndAngle
			If cStartAngle >= -180 And cEndAngle <= -90 Then
				'90 Left???
				ScaleStroke = cWidth / ScaleStrokeDivider
				RadiusInner = 0.74 * cWidth
				RadiusHalfTick = 0.78 * cWidth
				RadiusSmallTick = 0.765 * cWidth
				RadiusTick = 0.81 * cWidth
				RadiusScale = 0.67 * cWidth
			
				NeedleCenterX = 0.88 * cWidth
				NeedleCenterY = 0.88 * cWidth
				NeedleHeight = 2 * RadiusInner
				NeedleWidth = NeedleHeight / 340 * 20
			
				GaugeTextX = 0.7 * cWidth
				GaugeTextY = 0.65 * cWidth
				GaugeUnitX = GaugeTextX
				GaugeUnitY = GaugeTextY + (1.1 * 2) * rectGaugeTitle.Height
				GaugeAnalogValueX = GaugeTextX
				GaugeAnalogValueY =  GaugeTextY + 1.1 * rectGaugeTitle.Height
				
				DeltaTextBottom = 0.6 * ScaleTextHeight
			
				cScaleTextSize = 0.06 * cWidth / xui.Scale
				cNeedleIndex = 1
				
			Else If cStartAngle >= -90 And cEndAngle <= 0 Then
				'90 Right???
				ScaleStroke = cWidth / ScaleStrokeDivider
				RadiusInner = 0.74 * cWidth
				RadiusHalfTick = 0.78 * cWidth
				RadiusSmallTick = 0.765 * cWidth
				RadiusTick = 0.81 * cWidth
				RadiusScale = 0.67 * cWidth
			
				NeedleCenterX = 0.12 * cWidth
				NeedleCenterY = 0.88 * cWidth
				NeedleHeight = 2 * RadiusInner
				NeedleWidth = NeedleHeight / 340 * 20
			
				GaugeTextX = 0.3 * cWidth
				GaugeTextY = 0.65 * cWidth
				If cAnalogValueON = True Then
					GaugeUnitX = GaugeTextX
					GaugeUnitY = GaugeTextY + (1.1 * 2) * rectGaugeTitle.Height
				Else
					GaugeUnitX = GaugeTextX
					GaugeUnitY = GaugeTextY + 1.1 * rectGaugeTitle.Height
				End If
				GaugeAnalogValueX = GaugeTextX
				GaugeAnalogValueY =  GaugeTextY + 1.1 * rectGaugeTitle.Height
				
				DeltaTextBottom = 0.6 * ScaleTextHeight
			
				cScaleTextSize = 0.06 * cWidth / xui.Scale
				cNeedleIndex = 1
				
			Else If cStartAngle >= -190 And cEndAngle <= 10 Then
				'180???
				ScaleStroke = cWidth / ScaleStrokeDivider
				RadiusInner = 0.35 * cWidth
				RadiusHalfTick = 0.39 * cWidth
				RadiusSmallTick = 0.375 * cWidth
				RadiusTick = 0.42 * cWidth
				RadiusScale = 0.29 * cWidth
			
				NeedleCenterX = cWidth / 2
				NeedleCenterY = 0.55 * cWidth
				NeedleHeight = 2 * RadiusInner
				NeedleWidth = NeedleHeight / 340 * 27
		
				If cAnalogValueON = True Then
					GaugeTextX = cWidth / 2
					GaugeTextY = 0.37 * cWidth
					GaugeUnitX = GaugeTextX
					GaugeUnitY = GaugeTextY + (1.1 * 2) * rectGaugeTitle.Height
				Else
					GaugeTextX = cWidth / 2
					GaugeTextY = 0.40 * cWidth
					GaugeUnitX = GaugeTextX
					GaugeUnitY = GaugeTextY + 1.1 * rectGaugeTitle.Height
				End If
				GaugeAnalogValueX = GaugeTextX
				GaugeAnalogValueY =  GaugeTextY + 1.1 * rectGaugeTitle.Height
				
				DeltaTextBottom = 0.6 * ScaleTextHeight
				cNeedleIndex = 0
				
			Else If cStartAngle < -240 Or cEndAngle > 60 Then
				'Full 360???
				'somewhere 270 to 360?
				ScaleStroke = cWidth / ScaleStrokeDivider
				RadiusInner = 0.35 * cWidth
				RadiusHalfTick = 0.39 * cWidth
				RadiusSmallTick = 0.375 * cWidth
				RadiusTick = 0.42 * cWidth
				RadiusScale = 0.29 * cWidth
			
				NeedleCenterX = cWidth / 2
				NeedleCenterY = cWidth / 2
				NeedleHeight = 2 * RadiusInner
				NeedleWidth = NeedleHeight / 340 * 27
			
				GaugeTextX = cWidth / 2
				GaugeTextY = 0.40 * cWidth
				If cAnalogValueON = True Then
					GaugeUnitX = GaugeTextX
					GaugeUnitY = GaugeTextY + (1.1 * 4) * rectGaugeTitle.Height
				Else
					GaugeUnitX = GaugeTextX
					GaugeUnitY = GaugeTextY + (1.1 * 3) * rectGaugeTitle.Height
				End If
				GaugeAnalogValueX = GaugeTextX
				GaugeAnalogValueY =  GaugeTextY + (1.1 * 3) * rectGaugeTitle.Height

				DeltaTextBottom = 0.6 * ScaleTextHeight
				cNeedleIndex = 0
				
			Else
				'320???
				'somewhere 270 to 360?
				ScaleStroke = cWidth / ScaleStrokeDivider
				RadiusInner = 0.35 * cWidth
				RadiusHalfTick = 0.39 * cWidth
				RadiusSmallTick = 0.375 * cWidth
				RadiusTick = 0.42 * cWidth
				RadiusScale = 0.29 * cWidth
				
				NeedleCenterX = cWidth / 2
				NeedleCenterY = 0.55 * cWidth
				NeedleHeight = 2 * RadiusInner
				NeedleWidth = NeedleHeight / 340 * 27
		
				GaugeTextX = cWidth / 2
				GaugeTextY = 0.70 * cWidth
				If cAnalogValueON = True Then
					GaugeUnitX = GaugeTextX
					GaugeUnitY = GaugeTextY + (1.1 * 2) * rectGaugeTitle.Height
				Else
					GaugeUnitX = GaugeTextX
					GaugeUnitY = GaugeTextY + 1.1 * rectGaugeTitle.Height
				End If
				GaugeAnalogValueX = GaugeTextX
				GaugeAnalogValueY =  GaugeTextY + 1.1 * rectGaugeTitle.Height

				DeltaTextBottom = 0.8 * ScaleTextHeight
				cNeedleIndex = 0
				
			End If
	End Select
	
	Select cGaugeType
		Case "90° Top","180°", "270°", "90° Left", "Custom scale angles", "320°", "90° Right"
						
			ScaleHalfStroke = ScaleStroke / 1.5
			ScaleSmallStroke = ScaleStroke / 2
			
			cFullScaleAngle = cEndAngle - cStartAngle
			
			rectDigital2.Initialize(0, 0, cWidth, cHeight)
			pnlDigital2 = xui.CreatePanel("")
			pnlGauge.AddView(pnlDigital2, 0, 0, cWidth, cHeight)
			cvsDigital2.Initialize(pnlDigital2)

			rectNeedle.Initialize(0, 0, NeedleWidth, NeedleHeight)		
			pnlNeedle = xui.CreatePanel("")		
			pnlGauge.AddView(pnlNeedle, NeedleCenterX - NeedleWidth / 2, NeedleCenterY - NeedleHeight / 2, NeedleWidth, NeedleHeight)	
			cvsNeedle.Initialize(pnlNeedle)
			
			If cAnalogValueON = True Then DrawValue("-")
			
			DrawNeedle
			
			DrawScale
			
			RotateNeedle(0)
			
		Case "Digital Square"
			
			rectDigital.Initialize(0, 0, cWidth, cHeight)		
			pnlDigital = xui.CreatePanel("")		
			pnlGauge.AddView(pnlDigital, 0, 0, cWidth, cHeight)		
			cvsDigital.Initialize(pnlDigital)
			
			DrawDigital("-", "", "")
			
			DrawScaleDigitalSquare
			
		Case "Digital Circle"
			
			rectDigital.Initialize(0, 0, cWidth, cHeight)			
			pnlDigital = xui.CreatePanel("")
			pnlGauge.AddView(pnlDigital, 0, 0, cWidth, cHeight)
			cvsDigital.Initialize(pnlDigital)
			
			DrawDigital("-", "", "")
			
			DrawScaleDigitalCircle
	End Select
End Sub

Private Sub RotateNeedle(Value As Double)
	If pnlNeedle.IsInitialized Then
		Private Angle As Double
		
		cValue = Value
		Angle = cStartAngle + 90 + (cValue - cValueMin) / (cValueMax - cValueMin) * cFullScaleAngle
		pnlNeedle.Rotation = Angle
	End If
End Sub

Private Sub DrawScale

	Private Angle As Double
	Private DeltaAngle As Double
	Private x1, y1, x2, y2 As Int

	Dim cBorderWidth As Float
	Dim cBorderRadius, cBorderRadius2, cBorderRadius3 As Float
		
	'Border Width
	cBorderWidth = 0.024 * cWidth
	cBorderWidth = Round(cBorderWidth)
		
	'If Rounded Corners
	If cAnalogRoundedCorner = True Then
		Dim WhatWidthBorder As Float
		WhatWidthBorder = cBorderWidth
		cBorderRadius = 0.15 * cWidth
		cBorderRadius = Round(cBorderRadius)
		cBorderRadius2 = 0.15 * (cWidth - WhatWidthBorder * 2)
		cBorderRadius2 = Round(cBorderRadius2)
		cBorderRadius3 = 0.15 * (cWidth - WhatWidthBorder * 4)
		cBorderRadius3 = Round(cBorderRadius3)
	Else
		cBorderRadius = 0
		cBorderRadius2 = 0
		cBorderRadius3 = 0
	End If
	
	'This drawing is not basic.  Requires more memory and lags performance on loading
	If cBasicDrawing = False Then
		
		'Outter Bevel
		Dim bmp As B4XBitmap = DrawRoundedRect(cWidth, cHeight, cBorderRadius, Array As Int(cAnalogBorderColor, cAnalogBorderColor2), "TOP_BOTTOM")
		cvsGauge.DrawBitmap(bmp, rectGauge)

		'Inner Bevel
		If cAnalogInnerBevel = True Then
			Dim rectGauge10 As B4XRect
			rectGauge10.Initialize(cBorderWidth, cBorderWidth, cWidth - cBorderWidth, cHeight - cBorderWidth)
			Dim bmp2 As B4XBitmap = DrawRoundedRect(cWidth - cBorderWidth * 2, cHeight - cBorderWidth * 2, cBorderRadius2, Array As Int(cAnalogBorderColor, cAnalogBorderColor2), "BOTTOM_TOP")
			cvsGauge.DrawBitmap(bmp2, rectGauge10)
		End If
		
		'Background
		Dim RectGauge11 As B4XRect
		RectGauge11.Initialize(cBorderWidth * 2, cBorderWidth * 2, cWidth - cBorderWidth * 2, cHeight - cBorderWidth * 2)
		Dim bmp3 As B4XBitmap = DrawRoundedRect(cWidth - cBorderWidth * 4, cHeight - cBorderWidth * 4, cBorderRadius3, Array As Int(cBackgroundColor, cBackgroundColor), "TOP_BOTTOM")
		cvsGauge.DrawBitmap(bmp3, RectGauge11)
	
	Else
		Dim cbord As Float = 0.024 * cWidth
		
		'Border
		cvsGauge.DrawRect(rectGauge, cAnalogBorderColor, True, cBorderWidth)
	
		'Background
		Dim rectGauge7 As B4XRect
		rectGauge7.Initialize(cbord, cbord, cWidth - cbord, cHeight - cbord)
		cvsGauge.DrawRect(rectGauge7, cBackgroundColor, True, cBorderWidth)
	End If
		
	If cScaleLowLimitPerCent > 0 Then
		Private LowLimitAngle As Double
		Private pthScale As B4XPath
		LowLimitAngle = cFullScaleAngle * cScaleLowLimitPerCent / 100
		pthScale.InitializeArc(NeedleCenterX, NeedleCenterY, RadiusHalfTick, cStartAngle, LowLimitAngle)
		cvsGauge.DrawPath(pthScale, cScaleLowLimitColor, True, ScaleStroke)
		pthScale.InitializeArc(NeedleCenterX, NeedleCenterY, RadiusInner, cStartAngle - 2, LowLimitAngle + 5)
		cvsGauge.DrawPath(pthScale, cBackgroundColor, True, ScaleStroke)
	End If
	
	If cScaleHighLimitPerCent > 0 Then
		Private HighLimitAngle As Double
		Private pthScale As B4XPath
		HighLimitAngle = cFullScaleAngle * cScaleHighLimitPerCent / 100
		pthScale.InitializeArc(NeedleCenterX, NeedleCenterY, RadiusHalfTick, cEndAngle - HighLimitAngle, HighLimitAngle)
		cvsGauge.DrawPath(pthScale, cScaleHighLimitColor, True, ScaleStroke)
		pthScale.InitializeArc(NeedleCenterX, NeedleCenterY, RadiusInner, cEndAngle - HighLimitAngle - 2, HighLimitAngle + 5)
		cvsGauge.DrawPath(pthScale, cBackgroundColor, True, ScaleStroke)
	End If
	
	If cScaleMidLimitSweepPerCent > 0 Then
		Private LimitStartAngle, LimitSweepAngle As Double
		Private pthScale As B4XPath
		LimitStartAngle = cFullScaleAngle * cScaleMidLimitStartPerCent / 100
		LimitSweepAngle = cFullScaleAngle * cScaleMidLimitSweepPerCent / 100
		pthScale.InitializeArc(NeedleCenterX, NeedleCenterY, RadiusHalfTick, cStartAngle + LimitStartAngle, LimitSweepAngle)
		cvsGauge.DrawPath(pthScale, cScaleMidLimitColor, True, ScaleStroke)
		pthScale.InitializeArc(NeedleCenterX, NeedleCenterY, RadiusInner, cStartAngle + LimitStartAngle - 2, LimitSweepAngle + 5)
		cvsGauge.DrawPath(pthScale, cBackgroundColor, True, ScaleStroke)
	End If
	
	DeltaAngle = cFullScaleAngle / (cMainTickNumber - 1)
	For i = 0 To cMainTickNumber - 1
		Angle = -cStartAngle - i * DeltaAngle
		x1 = NeedleCenterX + CosD(Angle) * RadiusInner
		y1 = NeedleCenterY - SinD(Angle) * RadiusInner
		x2 = NeedleCenterX + CosD(Angle) * RadiusTick
		y2 = NeedleCenterY - SinD(Angle) * RadiusTick
		cvsGauge.DrawLine(x1, y1, x2, y2, cScaleColor, ScaleStroke)
	Next
	
	If cHalfTicks = True Then
		For i = 0 To cMainTickNumber - 2
			Angle = -cStartAngle - DeltaAngle / 2 - i * DeltaAngle
			x1 = NeedleCenterX + CosD(Angle) * RadiusInner
			y1 = NeedleCenterY - SinD(Angle) * RadiusInner
			x2 = NeedleCenterX + CosD(Angle) * RadiusHalfTick
			y2 = NeedleCenterY - SinD(Angle) * RadiusHalfTick
			cvsGauge.DrawLine(x1, y1, x2, y2, cScaleColor, ScaleHalfStroke)
		Next
	End If
	
	If cSmallTicksNumber > 0 Then
		DeltaAngle = cFullScaleAngle / (cMainTickNumber - 1) / cSmallTicksNumber
		For i = 0 To (cMainTickNumber - 1) * cSmallTicksNumber
			Angle = -cStartAngle - i * DeltaAngle
			x1 = NeedleCenterX + CosD(Angle) * RadiusInner
			y1 = NeedleCenterY - SinD(Angle) * RadiusInner
			x2 = NeedleCenterX + CosD(Angle) * RadiusSmallTick
			y2 = NeedleCenterY - SinD(Angle) * RadiusSmallTick
			cvsGauge.DrawLine(x1, y1, x2, y2, cScaleColor, ScaleSmallStroke)
		Next
	End If
	
	Private TickTexts() As String
	TickTexts = Regex.Split("\|", cTickText)
	DeltaAngle = cFullScaleAngle / (TickTexts.Length - 1)
	For i = 0 To TickTexts.Length - 1
		x1 = NeedleCenterX + CosD(-cStartAngle - i * DeltaAngle) * RadiusScale
		y1 = NeedleCenterY - SinD(-cStartAngle - i * DeltaAngle) * RadiusScale + DeltaTextBottom
		cvsGauge.DrawText(TickTexts(i), x1, y1, xui.CreateDefaultBoldFont(cScaleTextSize), cScaleColor, "CENTER")
	Next
	
	cvsGauge.DrawText(cGaugeTitle, GaugeTextX, GaugeTextY, xui.CreateDefaultBoldFont(cGaugeTitleTextSize), cAnalogTitleColor, "CENTER")
	cvsGauge.DrawText(cGaugeUnit, GaugeUnitX, GaugeUnitY, xui.CreateDefaultFont(cGaugeUnitTextSize), cAnalogUnitColor, "CENTER")

	cvsGauge.Invalidate
End Sub

Private Sub DrawNeedle
	Private pthNeedle As B4XPath
	Private x1, x2, r2 As Int

	If cNeedleBitmapFileName <> "no file" Then
		Private bmpNeedle As B4XBitmap
		bmpNeedle = xui.LoadBitmap(File.DirAssets, cNeedleBitmapFileName)
		NeedleWidth = NeedleHeight / bmpNeedle.Height * bmpNeedle.Width
		pnlNeedle.Left = NeedleCenterX - NeedleWidth / 2
		pnlNeedle.Width = NeedleWidth
		rectNeedle.Width = NeedleWidth
		cvsNeedle.Resize(NeedleWidth, NeedleHeight)
		cvsNeedle.ClearRect(rectNeedle)
		cvsNeedle.DrawBitmap(bmpNeedle, rectNeedle)
		cvsNeedle.Invalidate
	Else
		cvsNeedle.ClearRect(rectNeedle)
		Select cNeedleIndex
			Case 1
				x1 = cWidth / 25
				x2 = ScaleStroke
				r2 = NeedleWidth / 6
				pthNeedle.Initialize((NeedleWidth - x1) / 2, 0.5 * NeedleHeight)
				pthNeedle.LineTo((NeedleWidth - x2) / 2, 0)
				pthNeedle.LineTo((NeedleWidth + x2) / 2, 0)
				pthNeedle.LineTo((NeedleWidth + x1) / 2, 0.5 * NeedleHeight)
				cvsNeedle.DrawPath(pthNeedle, cNeedleColor, True, 1dip)
			Case 0
				x1 = cWidth / 30
				x2 = ScaleStroke
				r2 = NeedleWidth / 5
				pthNeedle.Initialize((NeedleWidth - x1) / 2, 0.65 * NeedleHeight)
				pthNeedle.LineTo((NeedleWidth - x2) / 2, 0)
				pthNeedle.LineTo((NeedleWidth + x2) / 2, 0)
				pthNeedle.LineTo((NeedleWidth + x1) / 2, 0.65 * NeedleHeight)
				cvsNeedle.DrawPath(pthNeedle, cNeedleColor, True, 1dip)
		End Select
		cvsNeedle.DrawCircle(NeedleWidth / 2, NeedleHeight / 2, NeedleWidth / 2, cNeedleColor, True, 1dip)
		cvsNeedle.DrawCircle(NeedleWidth / 2, NeedleHeight / 2, r2, cBackgroundColor, True, 1dip)
		cvsNeedle.Invalidate
	End If
End Sub

private Sub DrawValue(value As String)
	
	cvsDigital2.DrawRect(rectDigital2, xui.Color_Transparent, True, 1dip)

	cvsDigital2.DrawText(value, GaugeAnalogValueX, GaugeAnalogValueY, xui.CreateFont(Typeface.LoadFromAssets("digital.ttf"), cAnalogValueTextSize), cAnalogValueColor, "CENTER")
	
	cvsDigital2.Invalidate
End Sub

'sets or gets GaugeType property
'possible values 90° Top, 180°, 270°, 90° Left, 90° Right, 320°, Custom scale angles
'for Custom scale angles you can set the start and the end angle
Public Sub setGaugeType(GaugeType As String)
	If GaugeType <> "90° Right" And GaugeType <> "320°" And GaugeType <> "Digital Square" And GaugeType <> "Digital Circle" And GaugeType <> "90° Top" And GaugeType <> "180°" And GaugeType <> "270°" And GaugeType <> "90° Left" And GaugeType <> "Custom scale angles" Then
		Return
	End If
	cGaugeType = GaugeType
	ReInitialize
End Sub

Public Sub getGaugeType As String
	Return cGaugeType
End Sub

'sets the value of the Analog Gauge
'the value must be between ValueMin and ValueMax
Public Sub setValue (Value As Double)
	cValue = Min(Value, cValueMax)
	cValue = Max(Value, cValueMin)
	RotateNeedle(cValue)
End Sub

'gets or sets the min value of the gauge
Public Sub getValueMin As Int
	Return cValueMin
End Sub

Public Sub setValueMin(ValueMin As Int)
	cValueMin = ValueMin
	ReInitialize
End Sub

'gets or sets the max value of the gauge
Public Sub getValueMax As Int
	Return cValueMax
End Sub

Public Sub setValueMax(ValueMax As Int)
	cValueMax = ValueMax
	ReInitialize
End Sub

'gets or sets the number of main ticks
'for a scale from 0 to 10 then number must be 11
Public Sub getMainTickNumber As Int
	Return cMainTickNumber
End Sub

Public Sub setMainTickNumber(MainTickNumber As Int)
	cMainTickNumber = MainTickNumber
	ReInitialize
End Sub

'gets or sets if half (intermedaite) tick are required
'one tick between two main ticks
Public Sub getHalfTicks As Boolean
	Return cHalfTicks
End Sub

Public Sub setSmallTicksNumber(SmallTicksNumber As Int)
	cSmallTicksNumber = SmallTicksNumber + 1		'i added + 1 to avoid confusion. if smallticksnumber = 1 then it will display 1 tick in between
	ReInitialize
End Sub

'gets or sets the SmallTickNumber property
'SmallTicksNumber small ticks will drawn between two main ticks
'for a decimal scale SmallTickNumber = 10, eventhough only 9 ticks are seen, the 10th is hidden by the main tick
Public Sub getSmallTicksNumber As Int
	Return cSmallTicksNumber
End Sub

Public Sub setHalfTicks(HalfTicks As Boolean)
	cHalfTicks = HalfTicks
	ReInitialize
End Sub

'gets or sets the texts for the ticks
'the values between two || are displayed equally spaced on the scale
'Example: 0|20|40|60|80|100 or E|1/2|F
Public Sub getTickText As String
	Return cTickText
End Sub

Public Sub setTickText(TickText As String)
	cTickText = TickText
	ReInitialize
End Sub

'sets or gets the BackgroundColor
'it must be an xui.Color
'Example: xGauge1.BackgroundColor = xui.Color_White
Public Sub setBackgroundColor(Color As Int)
	cBackgroundColor = Color
	ReInitialize
End Sub

Public Sub getBackgroundColor As Int
	Return cBackgroundColor
End Sub

'sets or gets the ScaleColor
'it must be an xui.Color
'Example: xGauge1.ScaleColor = xui.Color_Black
Public Sub setScaleColor(ScaleColor As Int)
	cScaleColor = ScaleColor
	ReInitialize	'prefered
'	If pnlGauge.IsInitialized Then
'		DrawScale
'	End If

End Sub

Public Sub getScaleColor As Int
	Return cScaleColor
End Sub

'sets or gets the NeedleColor
'it must be an xui.Color
'Example: xGauge1.NeedleColor = xui.Color_Gray
Public Sub setNeedleColor(NeedleColor As Int)
	cNeedleColor = NeedleColor
	ReInitialize
End Sub

Public Sub getNeedleColor As Int
	Return cNeedleColor
End Sub

'sets or gets GaugeTitle property
Public Sub setGaugeTitle(GaugeTitle As String)
	cGaugeTitle = GaugeTitle
	ReInitialize	'prefered
'	If pnlGauge.IsInitialized Then
'		If cGaugeType = "Digital Square" Then
'			DrawScaleDigital
'		Else
'			DrawScale
'		End If
'	End If
End Sub

Public Sub getGaugeTitle As String
	Return cGaugeTitle
End Sub

'sets or gets GaugeUnit property
Public Sub setGaugeUnit(GaugeUnit As String)
	cGaugeUnit = GaugeUnit
	ReInitialize	'prefered
'	If pnlGauge.IsInitialized Then
'		If cGaugeType = "Digital Square" Then
'			DrawScaleDigital
'		Else
'			DrawScale
'		End If
'	End If
End Sub

Public Sub getGaugeUnit As String
	Return cGaugeUnit
End Sub

'sets or gets the width of the gauge
'there is no height property because the height is equal to the width
Public Sub setWidth(Width As Double)
	cWidth = Width
	ReInitialize
End Sub

Public Sub getWidth As Double
	Return cWidth
End Sub

'sets or gets the Left property
Public Sub setLeft(Left As Double)
	cLeft = Left
	pnlGauge.Left = cLeft
End Sub

Public Sub getLeft As Double
	Return cLeft
End Sub

'sets or gets the Top property
Public Sub setTop(Top As Double)
	cTop = Top
	pnlGauge.Top = Top
End Sub

Public Sub getTop As Double
	Return cTop
End Sub

'sets or gets the ScaleLowLimitPerCent property
'given in pecent of the scale
'it drawn from the scale start to the given percent
Public Sub setScaleLowLimitPerCent(ScaleLowLimitPerCent As Double)
	cScaleLowLimitPerCent = ScaleLowLimitPerCent
	ReInitialize
End Sub

Public Sub getScaleLowLimitPerCent As Double
	Return cScaleLowLimitPerCent
End Sub

'sets or gets the ScaleLowLimitColor
'it must be an xui.Color
'Example: xGauge1.NeedleColor = xui.Color_RGB(526, 165, 0)
Public Sub setScaleLowLimitColor(ScaleLowLimitColor As Int)
	cScaleLowLimitColor = ScaleLowLimitColor
	ReInitialize
End Sub

Public Sub getScaleLowLimitColor As Int
	Return cScaleLowLimitColor
End Sub

'sets or gets the ScaleHighLimitPerCent property
'it is drawn from the given percent to the scale end
'given in pecent of the scale
Public Sub setScaleHighLimitPerCent(ScaleHighLimitPerCent As Double)
	cScaleHighLimitPerCent = ScaleHighLimitPerCent
	ReInitialize
End Sub

Public Sub getScaleHighLimitPerCent As Double
	Return cScaleHighLimitPerCent
End Sub

'sets or gets the ScaleHighLimitColor
'it must be an xui.Color
'Example: xGauge1.ScaleHighLimitColor = xui.Color_Red
Public Sub setScaleHighLimitColor(ScaleHighLimitColor As Int)
	cScaleHighLimitColor = ScaleHighLimitColor
	ReInitialize
End Sub

Public Sub getScaleHighLimitColor As Int
	Return cScaleHighLimitColor
End Sub

'sets or gets the ScaleMidLimitStartPerCent property
'it is drawn from the given start percent over the sweep percent
'given in pecent of the scale
Public Sub setScaleMidLimitStartPerCent(ScaleMidLimitStartPerCent As Double)
	cScaleMidLimitStartPerCent = ScaleMidLimitStartPerCent
	ReInitialize
End Sub

Public Sub getScaleMidLimitStartPerCent As Double
	Return cScaleMidLimitStartPerCent
End Sub

'sets or gets the ScaleMidLimitSweepPerCent property
'it is drawn from the given start percent over the sweep percent
'given in pecent of the scale
Public Sub setScaleMidLimitSweepPerCent(ScaleMidLimitSweepPerCent As Double)
	cScaleMidLimitSweepPerCent = ScaleMidLimitSweepPerCent
	ReInitialize
End Sub

Public Sub getScaleMidLimitSweepPerCent As Double
	Return cScaleMidLimitSweepPerCent
End Sub

'sets or gets the ScaleMidLimitColor
'it must be an xui.Color
'Example: xGauge1.ScaleMidLimitColor = xui.Color_RGB(526, 165, 0)
Public Sub setScaleMidLimitColor(ScaleMidLimitColor As Int)
	cScaleMidLimitColor = ScaleMidLimitColor
	ReInitialize
End Sub

Public Sub getScaleMidLimitColor As Int
	Return cScaleMidLimitColor
End Sub

'sets or gets the NeedleBitmapFileName property
'enter 'no file' without the quotes to use the default needle
Public Sub setNeedleBitmapFileName(NeedleBitmapFileName As String)
	cNeedleBitmapFileName = NeedleBitmapFileName
	ReInitialize
End Sub

Public Sub getNeedleBitmapFileName As String
	Return cNeedleBitmapFileName
End Sub

'sets or gets the NeedleON property
'shows or hides the needle
'default value True
'Not needed in this project.
Public Sub setNeedleON(NeedleON As Boolean)
	cNeedleON = NeedleON
	pnlNeedle.Visible = cNeedleON
End Sub

Public Sub getNeedleON As Boolean
	Return cNeedleON
End Sub

'sets or gets the CustomScaleStartAngle
'Start angle for Custom scale angle gauge type.
'trigonometric angles 0 at 3 o'clock
'positive clockwise
Public Sub setCustomScaleStartAngle(CustomScaleStartAngle As Int)
	cCustomScaleStartAngle = CustomScaleStartAngle
	If cCustomScaleEndAngle - cCustomScaleStartAngle > cCustomScaleMaxAngle Then
		cCustomScaleEndAngle = cCustomScaleStartAngle + cCustomScaleMaxAngle
	Else If cCustomScaleEndAngle - cCustomScaleStartAngle < cCustomScaleMinAngle Then
		cCustomScaleEndAngle = cCustomScaleStartAngle + cCustomScaleMinAngle
	End If
	ReInitialize
End Sub

Public Sub getCustomScaleStartAngle As Int
	Return cCustomScaleStartAngle
End Sub

'sets or gets the CustomScaleEndAngle
'Start angle for Custom scale angle gauge type.
'trigonometric angles 0 at 3 o'clock
'positive clockwise
Public Sub setCustomScaleEndAngle(CustomScaleEndAngle As Int)
	cCustomScaleEndAngle = CustomScaleEndAngle
	If cCustomScaleEndAngle - cCustomScaleStartAngle > cCustomScaleMaxAngle Then
		cCustomScaleStartAngle = cCustomScaleEndAngle - cCustomScaleMaxAngle
	Else If cCustomScaleEndAngle - cCustomScaleStartAngle < cCustomScaleMinAngle Then
		cCustomScaleStartAngle = cCustomScaleEndAngle - cCustomScaleMinAngle
	End If
	ReInitialize
End Sub

Public Sub getCustomScaleEndAngle As Int
	Return cCustomScaleEndAngle
End Sub

'removes the xGauge from its parent view
Public Sub RemoveView
	pnlGauge.RemoveViewFromParent
End Sub

'If using this method then enalbe it in the class
'reinitializes the gauge
'This is causing performance issue with my project.  use below reinitialize2
Public Sub ReInitialize	'Disable this not using it that way.  causes delays with my project
'	If pnlGauge.IsInitialized Then
'		InitHeight
'		pnlGauge.RemoveViewFromParent
'		pnlGauge = xui.CreatePanel("pnlGauge")
'		cParent.AddView(pnlGauge, cLeft, cTop, cWidth, cHeight)
'		If pnlNeedle.IsInitialized Then pnlNeedle.RemoveViewFromParent
'		If pnlDigital.IsInitialized Then pnlDigital.RemoveViewFromParent
'		If pnlDigital2.IsInitialized Then pnlDigital2.RemoveViewFromParent
'		InitGauge
''		DrawNeedle
'	End If
End Sub
Public Sub ReInitialize2	'Add this to Klaus every update
	If pnlGauge.IsInitialized Then
		InitHeight
		pnlGauge.RemoveViewFromParent
		pnlGauge = xui.CreatePanel("pnlGauge")
		cParent.AddView(pnlGauge, cLeft, cTop, cWidth, cHeight)
		If pnlNeedle.IsInitialized Then pnlNeedle.RemoveViewFromParent	'Analog Gauge Needle
		If pnlDigital.IsInitialized Then pnlDigital.RemoveViewFromParent 'Digital Square/Circle
		If pnlDigital2.IsInitialized Then pnlDigital2.RemoveViewFromParent 'Analog Gauge Digital Value
		InitGauge
'		DrawNeedle	'Conflict with Digital gauges. not needed.  initGauge will do this if selected
	End If
End Sub

Private Sub InitHeight
	cHeight = cWidth
	Select cGaugeType
		Case "180°"
			cHeight = 0.7 * cWidth
		Case "Custom scale angles"
			cStartAngle = cCustomScaleStartAngle
			cEndAngle = cCustomScaleEndAngle
			If cStartAngle >= -190 And cStartAngle < -90 And cEndAngle > -90 And cEndAngle <= 10 Then
				cHeight = 0.7 * cWidth
			End If
	End Select
End Sub

'---------------------------------------------------------
'Note to Self: Add these to every Klaus Update
'---------------------------------------------------------
public Sub BringToFront
	pnlGauge.BringToFront
End Sub
public Sub SendToBack
	pnlGauge.SendToBack
End Sub

public Sub setTag(TagValue As String)
	cTag = TagValue
End Sub
public Sub getTag As String
	Return cTag
End Sub

public Sub getHeight As Double
	Return cHeight
End Sub

Private Sub pnlGauge_Click
	If SubExists(mCallBack, mEventName & "_Click") Then
		CallSub(mCallBack, mEventName & "_Click")
	End If
End Sub
Private Sub pnlGauge_LongClick
	If SubExists(mCallBack, mEventName & "_LongClick") Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub

public Sub getisInitialized2 As Boolean
	Return pnlGauge.IsInitialized
End Sub

'sets or gets Digital Gauge Value Label Color
'it must be an xui.Color
Public Sub setDigitalValueColor(Color As Int)
	cDigitalValueColor = Color
	ReInitialize
End Sub
Public Sub getDigitalValueColor As Int
	Return cDigitalValueColor
End Sub

'sets or gets Digital Gauge Background Color
'it must be an xui.Color
Public Sub setDigitalBackgroundColor(Color As Int)
	cDigitalBackgroundColor = Color
	ReInitialize
End Sub
Public Sub getDigitalBackgroundColor As Int
	Return cDigitalBackgroundColor
End Sub

'sets or gets Digital Gauge Background Color 2
Public Sub setDigitalBackgroundColor2(Color As Int)
	cDigitalBackgroundColor2 = Color
	ReInitialize
End Sub
Public Sub getDigitalBackgroundColor2 As Int
	Return cDigitalBackgroundColor2
End Sub

''sets or gets Digital Gauge Title Color
'it must be an xui.Color
Public Sub setDigitalTitleColor(Color As Int)
	CDigitalTitleColor = Color
	ReInitialize

End Sub
Public Sub getDigitalTitleColor As Int
	Return CDigitalTitleColor
End Sub

'Digital Gauge Unit Color
'it must be an xui.Color
Public Sub setDigitalUnitColor(Color As Int)
	CDigitalUnitColor = Color
	ReInitialize

End Sub
Public Sub getDigitalUnitColor As Int
	Return CDigitalUnitColor
End Sub

'sets or gets Digital Gauge Border Color
Public Sub setDigitalBorderColor(Color As Int)
	cDigitalBorderColor = Color
	ReInitialize

End Sub
Public Sub getDigitalBorderColor As Int
	Return cDigitalBorderColor
	
End Sub

'sets or gets Digital Gauge Border Color 2
'it must be an xui.Color
Public Sub setDigitalBorderColor2(Color As Int)
	cDigitalBorderColor2 = Color
	ReInitialize

End Sub
Public Sub getDigitalBorderColor2 As Int
	Return cDigitalBorderColor2
	
End Sub

'sets or gets Analog Gauge Border Color
'it must be an xui.Color
Public Sub setAnalogBorderColor(Color As Int)
	cAnalogBorderColor = Color
	ReInitialize
	
End Sub
Public Sub getAnalogBorderColor As Int
	Return cAnalogBorderColor
End Sub

'sets or gets Analog Gauge Border Color 2
'it must be an xui.Color
Public Sub setAnalogBorderColor2(Color As Int)
	cAnalogBorderColor2 = Color
	ReInitialize
	
End Sub
Public Sub getAnalogBorderColor2 As Int
	Return cAnalogBorderColor2
End Sub

'Analog Gauge Title Color
'it must be an xui.Color
Public Sub setAnalogTitleColor(Color As Int)
	cAnalogTitleColor = Color
	ReInitialize
	
End Sub
Public Sub getAnalogTitleColor As Int
	Return cAnalogTitleColor
End Sub

'sets or gets Analog Gauge Unit Color
'it must be an xui.Color
Public Sub setAnalogUnitColor(Color As Int)
	cAnalogUnitColor = Color
	ReInitialize
	
End Sub
Public Sub getAnalogUnitColor As Int
	Return cAnalogUnitColor
End Sub

'sets or gets Analog Gauge Digital Value Label Color
'it must be an xui.Color
Public Sub setAnalogValueColor(Color As Int)
	cAnalogValueColor = Color
	ReInitialize
	
End Sub
Public Sub getAnalogValueColor As Int
	Return cAnalogValueColor
End Sub

'sets or gets 
'Display Option to show Digital Value Label in Analog Gauge type
Public Sub setAnalogValueON(ValueON As Boolean)
	cAnalogValueON = ValueON
	ReInitialize
End Sub
Public Sub getAnalogValueON As Boolean
	Return cAnalogValueON
End Sub

'sets or gets 
'Display Option to show Rounded Corners for Analog Gauge Type
Public Sub setAnalogRoundedCorner(blnRounded As Boolean)
	cAnalogRoundedCorner = blnRounded
	ReInitialize
End Sub
Public Sub getAnalogRoundedCorner As Boolean
	Return cAnalogRoundedCorner
End Sub

'sets or gets 
'Display Option to show Rounded Corners for Digital Gauge Type
Public Sub setDigitalRoundedCorner(blnRounded As Boolean)
	cDigitalRoundedCorner = blnRounded
	ReInitialize
End Sub
Public Sub getDigitalRoundedCorner As Boolean
	Return cDigitalRoundedCorner
End Sub

'sets or gets 
'Display Option to show Thicker Border for Digital Gauge Type
Public Sub setDigitalThickBorder(blnThick As Boolean)
	cDigitalThickBorder = blnThick
	ReInitialize
End Sub
Public Sub getDigitalThickBorder As Boolean
	Return cDigitalThickBorder
End Sub

'sets or gets 
'Display Option to show Inner Bevel for Digital Gauge Type
Public Sub setDigitalInnerBevel(blnShow As Boolean)
	cDigitalInnerBevel = blnShow
	ReInitialize
End Sub
Public Sub getDigitalInnerBevel As Boolean
	Return cDigitalInnerBevel
End Sub

'sets or gets 
'Display Option to show Inner Bevel for Analog Gauge Type
Public Sub setAnalogInnerBevel(blnShow As Boolean)
	cAnalogInnerBevel = blnShow
	ReInitialize
End Sub
Public Sub getAnalogInnerBevel As Boolean
	Return cAnalogInnerBevel
End Sub

'sets or gets 
'Basic Drawing with only simple border (Faster Performance)
Public Sub setBasicDrawing(blnOK As Boolean)
	cBasicDrawing = blnOK
	ReInitialize
End Sub
Public Sub getBasicDrawing As Boolean
	Return cBasicDrawing
End Sub

'sets or gets 
'Display Option for Min and Max
Public Sub setDigitalMinMaxON(blnOK As Boolean)
	cDigitalMinMaxON = blnOK
	ReInitialize
End Sub
Public Sub getDigitalMinMaxON As Boolean
	Return cDigitalMinMaxON
End Sub

Private Sub DrawScaleDigitalSquare
	
	'This drawing is not basic.  Requires more memory and lags performance on loading
	If cBasicDrawing = False Then
		Dim cBorderWidth, cBorderWidth2 As Float
		Dim cBorderRadius, cBorderRadius2, cBorderRadius3 As Float
		
		'Border Width (Thick or Not)
		cBorderWidth = 0.024 * cWidth
		cBorderWidth2 = 0.036 * cWidth
		cBorderWidth = Round(cBorderWidth)
		cBorderWidth2 = Round(cBorderWidth2)
		
		'If Rounded Corners
		If cDigitalRoundedCorner = True Then
			Dim WhatWidthBorder As Float
			If cDigitalThickBorder = True Then
				WhatWidthBorder = cBorderWidth2
			Else
				WhatWidthBorder = cBorderWidth
			End If
			If cDigitalThickBorder = True Then
				cBorderRadius = 0.15 * cWidth
				cBorderRadius = Round(cBorderRadius)
				cBorderRadius2 = 0.15 * (cWidth - WhatWidthBorder * 3)
				cBorderRadius2 = Round(cBorderRadius2)
				cBorderRadius3 = 0.15 * (cWidth - WhatWidthBorder * 4.5)
				cBorderRadius3 = Round(cBorderRadius3)
			Else
				cBorderRadius = 0.15 * cWidth
				cBorderRadius = Round(cBorderRadius)
				cBorderRadius2 = 0.15 * (cWidth - WhatWidthBorder * 2)
				cBorderRadius2 = Round(cBorderRadius2)
				cBorderRadius3 = 0.15 * (cWidth - WhatWidthBorder * 4)
				cBorderRadius3 = Round(cBorderRadius3)
			End If
		Else
			cBorderRadius = 0
			cBorderRadius2 = 0
			cBorderRadius3 = 0
		End If
		
		If cDigitalThickBorder = False Then

			'Outter Bevel
			Dim bmp As B4XBitmap = DrawRoundedRect(cWidth, cHeight, cBorderRadius, Array As Int(cDigitalBorderColor, cDigitalBorderColor2), "TOP_BOTTOM")
			cvsGauge.DrawBitmap(bmp, rectGauge2)

			'Inner Bevel
			If cDigitalInnerBevel = True Then
				Dim rectGauge22 As B4XRect
				rectGauge22.Initialize(cBorderWidth, cBorderWidth, cWidth - cBorderWidth, cHeight - cBorderWidth)
				Dim bmp2 As B4XBitmap = DrawRoundedRect(cWidth - cBorderWidth * 2, cHeight - cBorderWidth * 2, cBorderRadius2, Array As Int(cDigitalBorderColor, cDigitalBorderColor2), "BOTTOM_TOP")
				cvsGauge.DrawBitmap(bmp2, rectGauge22)
			End If
			
			'Background
			Dim RectGauge23 As B4XRect
			RectGauge23.Initialize(cBorderWidth * 2, cBorderWidth * 2, cWidth - (cBorderWidth * 2), cHeight - (cBorderWidth * 2))
'			Dim bmp3 As B4XBitmap = DrawRoundedRect(cWidth - cBorderWidth * 4, cHeight - cBorderWidth * 4, cBorderRadius, Array As Int(cDigitalBackgroundColor, cDigitalBackgroundColor2), "TOP_BOTTOM")
			Dim bmp3 As B4XBitmap = DrawRoundedRectSpecial(cWidth - cBorderWidth * 4, cHeight - cBorderWidth * 4, cBorderRadius3, Array As Int(cDigitalBackgroundColor, cDigitalBackgroundColor2))			
			cvsGauge.DrawBitmap(bmp3, RectGauge23)
		Else
			
	'		Outer Bevel
			Dim bmp As B4XBitmap = DrawRoundedRect(cWidth, cHeight, cBorderRadius, Array As Int(cDigitalBorderColor, cDigitalBorderColor2), "TOP_BOTTOM")
			cvsGauge.DrawBitmap(bmp, rectGauge2)
	
			'Inner Bevel
			If cDigitalInnerBevel = True Then
				Dim rectGauge22 As B4XRect
				rectGauge22.Initialize(cBorderWidth2 + (cBorderWidth2/2), cBorderWidth2 + (cBorderWidth2/2), cWidth - (cBorderWidth2 + cBorderWidth2/2), cHeight - (cBorderWidth2 + cBorderWidth2/2))
				Dim bmp2 As B4XBitmap = DrawRoundedRect(cWidth - cBorderWidth2 * 3, cHeight - cBorderWidth2 * 3, cBorderRadius2, Array As Int(cDigitalBorderColor, cDigitalBorderColor2), "BOTTOM_TOP")
				cvsGauge.DrawBitmap(bmp2, rectGauge22)
			End If
			
			'Background
			Dim RectGauge23 As B4XRect
			RectGauge23.Initialize(cBorderWidth2 * 2.25, cBorderWidth2 * 2.25, cWidth - (cBorderWidth2 * 2.25), cHeight - (cBorderWidth2 * 2.25))
'			Dim bmp3 As B4XBitmap = DrawRoundedRect(cWidth - cBorderWidth2 * 4.5, cHeight - cBorderWidth2 * 4.5, cBorderRadius, Array As Int(cDigitalBackgroundColor, cDigitalBackgroundColor2), "TOP_BOTTOM")
			Dim bmp3 As B4XBitmap = DrawRoundedRectSpecial(cWidth - cBorderWidth2 * 4.5, cHeight - cBorderWidth2 * 4.5, cBorderRadius3, Array As Int(cDigitalBackgroundColor, cDigitalBackgroundColor2))
			cvsGauge.DrawBitmap(bmp3, RectGauge23)
		End If
	Else
		Dim cbord As Float = 0.024 * cWidth
	
		'Border
		cvsGauge.DrawRect(rectGauge2, cDigitalBorderColor, True, cbord)

		'Background
		Dim rectGauge6 As B4XRect
		rectGauge6.Initialize(cbord, cbord, cWidth - cbord, cHeight - cbord)
		cvsGauge.DrawRect(rectGauge6, cDigitalBackgroundColor, True, cbord)
	End If
	
	cvsGauge.DrawText(cGaugeTitle, GaugeTextX, GaugeTextY, xui.CreateDefaultBoldFont(cGaugeTitleTextSize), CDigitalTitleColor, "CENTER")
	cvsGauge.DrawText(cGaugeUnit, GaugeUnitX, GaugeUnitY, xui.CreateDefaultFont(cGaugeUnitTextSize), CDigitalUnitColor, "CENTER")

	cvsGauge.Invalidate
End Sub
Private Sub DrawScaleDigitalCircle
	
	'This drawing is not basic.  Requires more memory and lags performance on loading
	If cBasicDrawing = False Then
		
		If cDigitalThickBorder = False Then
			Dim cBorderWidth As Float = 0.024 * cWidth
			cBorderWidth = Round(cBorderWidth)
			
			'Outter Bevel
			Dim bmp As B4XBitmap = DrawRadial(cWidth, cHeight, Array As Int(cDigitalBorderColor, cDigitalBorderColor2), "TOP_BOTTOM")
			cvsGauge.DrawBitmap(bmp, rectGauge2)
			
			'Inner Bevel
			If cDigitalInnerBevel = True Then
				Dim rectGauge22 As B4XRect
				rectGauge22.Initialize(cBorderWidth, cBorderWidth, cWidth - cBorderWidth, cHeight - cBorderWidth)
				Dim bmp2 As B4XBitmap = DrawRadial(cWidth - cBorderWidth * 2, cHeight - cBorderWidth * 2, Array As Int(cDigitalBorderColor, cDigitalBorderColor2), "BOTTOM_TOP")
				cvsGauge.DrawBitmap(bmp2, rectGauge22)
			End If
			
			'Background
			Dim RectGauge23 As B4XRect
			RectGauge23.Initialize(cBorderWidth * 2, cBorderWidth * 2, cWidth - (cBorderWidth * 2), cHeight - (cBorderWidth * 2))
'			Dim bmp3 As B4XBitmap = DrawRadial(cWidth - cBorderWidth * 4, cHeight - cBorderWidth * 4, Array As Int(cDigitalBackgroundColor, cDigitalBackgroundColor2), "TOP_BOTTOM")
			Dim bmp3 As B4XBitmap = DrawRadialSpecial(cWidth - cBorderWidth * 4, cHeight - cBorderWidth * 4, Array As Int(cDigitalBackgroundColor, cDigitalBackgroundColor2))
			cvsGauge.DrawBitmap(bmp3, RectGauge23)
		Else
			Dim cBorderWidth As Float = 0.036 * cWidth
			cBorderWidth = Round(cBorderWidth)
			
			'Outer Bevel			
			Dim bmp As B4XBitmap = DrawRadial(cWidth, cHeight, Array As Int(cDigitalBorderColor, cDigitalBorderColor2), "TOP_BOTTOM")
			cvsGauge.DrawBitmap(bmp, rectGauge2)
			
			'Inner Bevel
			If cDigitalInnerBevel = True Then
				Dim rectGauge22 As B4XRect
				rectGauge22.Initialize(cBorderWidth + (cBorderWidth/2), cBorderWidth + (cBorderWidth/2), cWidth - (cBorderWidth + cBorderWidth/2), cHeight - (cBorderWidth + cBorderWidth/2))
				Dim bmp2 As B4XBitmap = DrawRadial(cWidth - cBorderWidth * 3, cHeight - cBorderWidth * 3, Array As Int(cDigitalBorderColor, cDigitalBorderColor2), "BOTTOM_TOP")
				cvsGauge.DrawBitmap(bmp2, rectGauge22)
			End If
			
			'Background
			Dim RectGauge23 As B4XRect
			RectGauge23.Initialize(cBorderWidth * 2.25, cBorderWidth * 2.25, cWidth - (cBorderWidth * 2.25), cHeight - (cBorderWidth * 2.25))
'			Dim bmp3 As B4XBitmap = DrawRadial(cWidth - cBorderWidth * 4.5, cHeight - cBorderWidth * 4.5, Array As Int(cDigitalBackgroundColor, cDigitalBackgroundColor2), "TOP_BOTTOM")
			'This will draw radial gradient
			Dim bmp3 As B4XBitmap = DrawRadialSpecial(cWidth - cBorderWidth * 4.5, cHeight - cBorderWidth * 4.5, Array As Int(cDigitalBackgroundColor, cDigitalBackgroundColor2))			
			cvsGauge.DrawBitmap(bmp3, RectGauge23)
		End If
	Else
		Dim cbord As Float = 0.024 * cWidth
	
		'Border
		cvsGauge.DrawCircle(cWidth/2, cHeight/2, cWidth/2, cDigitalBorderColor, True, cbord)

		'Background
		cvsGauge.DrawCircle(cWidth/2, cHeight/2, (cWidth/2) - cbord, cDigitalBackgroundColor, True, cbord)
	End If
	
	cvsGauge.DrawText(cGaugeTitle, GaugeTextX, GaugeTextY, xui.CreateDefaultBoldFont(cGaugeTitleTextSize), CDigitalTitleColor, "CENTER")
	cvsGauge.DrawText(cGaugeUnit, GaugeUnitX, GaugeUnitY, xui.CreateDefaultFont(cGaugeUnitTextSize), CDigitalUnitColor, "CENTER")

	cvsGauge.Invalidate
End Sub

'Value can be ON/OFF or any strings
private Sub DrawDigital(value As String, Min1 As String, Max1 As String)
	
	cvsDigital.DrawRect(rectDigital, xui.Color_Transparent, True, 1dip)

	cvsDigital.DrawText(value, GaugeDigitalValueX, GaugeDigitalValueY, xui.CreateFont(Typeface.LoadFromAssets("digital.ttf"), cDigitalValueTextSize), cDigitalValueColor, "CENTER")
	
	If cDigitalMinMaxON = True Then
		'Only use with Square Type Gauge
		If cGaugeType = "Digital Square" Then
			cvsDigital.DrawText(Min1, GaugeDigitalMinX, GaugeDigitalMinY, xui.CreateFont(Typeface.LoadFromAssets("digital.ttf"), cDigitalValueTextSize/2.2), cDigitalValueColor, "CENTER")
			cvsDigital.DrawText(Max1, GaugeDigitalMaxX, GaugeDigitalMaxY, xui.CreateFont(Typeface.LoadFromAssets("digital.ttf"), cDigitalValueTextSize/2.2), cDigitalValueColor, "CENTER")
		End If
	End If
	
	cvsDigital.Invalidate
End Sub

'sets the value of Analog Gauge
'This is Digital Label in Analog Gauge
public Sub setValueB (Value As Double)
	If cAnalogValueON = True Then
		If pnlDigital2.IsInitialized Then DrawValue(Value)
	End If
End Sub

'sets the value of Analog Gauge
'This is Smooth Sweep. Use from 1 to 25 ms (It has a multiplier by 20)
Public Sub Value2 (Value As Double, ms As String)
	'Animation Rotation.  Smooth Sweep
	cValue = Min(Value, cValueMax)
	cValue = Max(Value, cValueMin)
	RotateNeedle2(cValue, ms)
End Sub
Private Sub RotateNeedle2(Value As Double, ms As String)
	If pnlNeedle.IsInitialized Then
		Private Angle As Double
		
		cValue = Value
		Angle = cStartAngle + 90 + (cValue - cValueMin) / (cValueMax - cValueMin) * cFullScaleAngle
		pnlNeedle.SetRotationAnimated(ms * 20, Angle)
	End If
End Sub

'sets the value of Digital Gauge
'This is for Digital Circle and Square Types.  Min and Max not used with Circle Type.
'Min and Max value will not be automatically determined.  You must determine the Min and Max Value
public Sub ValueDigital (Value As String, Min1 As String, Max1 As String)
	'Value must be String.  Can display On/Off or any strings
	DrawDigital(Value, Min1, Max1)
End Sub

'Slow!!
Sub DrawRoundedRect(Width As Int, Height As Int, Radius As Int, Clrs() As Int, Orientation As String) As B4XBitmap
	Dim Gradient As BitmapCreator
	Gradient.Initialize(10, Height)
	Gradient.FillGradient(Clrs, Gradient.TargetRect, Orientation)
	Dim Brush As BCBrush = Gradient.CreateBrushFromBitmapCreator(Gradient)
	Dim bc As BitmapCreator
	bc.Initialize(Width, Height)
	bc.DrawRectRounded2(bc.TargetRect, Brush, True, 0, Radius)
	Return bc.Bitmap
End Sub
Sub DrawRoundedRectSpecial(Width As Int, Height As Int, Radius As Int, Clrs() As Int) As B4XBitmap
	Dim Gradient As BitmapCreator
	Gradient.Initialize(Width, Height)
	Gradient.FillRadialGradient(Clrs, Gradient.TargetRect)
	Dim Brush As BCBrush = Gradient.CreateBrushFromBitmapCreator(Gradient)
	Dim bc As BitmapCreator
	bc.Initialize(Width, Height)
	bc.DrawRectRounded2(bc.TargetRect, Brush, True, 0, Radius)
	Return bc.Bitmap
End Sub

'need to correct the fraction numbers. 
Sub DrawRadial(Width As Int, Height As Int, Clrs() As Int, Orientation As String) As B4XBitmap
	Dim Gradient As BitmapCreator
	Gradient.Initialize(10, Height)
	Gradient.FillGradient(Clrs, Gradient.TargetRect, Orientation)
	Dim Brush As BCBrush = Gradient.CreateBrushFromBitmapCreator(Gradient)
	Dim bc As BitmapCreator
	bc.Initialize(Width, Height)
	Dim xWidth As Float = Floor(Width/2)
	Dim xHeight As Float = Floor(Height/2)
	bc.DrawCircle2(xWidth, xHeight, xWidth, Brush, True, 0)
	Return bc.Bitmap
End Sub
Sub DrawRadialSpecial(Width As Int, Height As Int, Clrs() As Int) As B4XBitmap
	Dim Gradient As BitmapCreator
	Gradient.Initialize(Width, Height)
'	Gradient.FillGradient(Clrs, Gradient.TargetRect, Orientation)
	Gradient.FillRadialGradient(Clrs, Gradient.TargetRect)
	Dim Brush As BCBrush = Gradient.CreateBrushFromBitmapCreator(Gradient)
	Dim bc As BitmapCreator
	bc.Initialize(Width, Height)
	Dim xWidth As Float = Floor(Width/2)
	Dim xHeight As Float = Floor(Height/2)
	bc.DrawCircle2(xWidth, xHeight, xWidth, Brush, True, 0)
	Return bc.Bitmap
End Sub

